# Simul_ACH_noOut.s

library(MASS)
remove(list=ls())

source(file="C:/Users/Alfio/Desktop/Negbin/AeberhardCantoniHeritier/glmrob.nb_V3.r")         

#-------------------------------------------------------------------------------
   
p = 6; Sigma0 = diag(1,p-1); Mu0 = c(0,0,0,0,0)
Beta0  = c(1.5, 0.5, 0.25,0,0,0); alpha0 = 0.8; size0  = 1/alpha0

epsilon = 0.15
xout= c(-2,-1,0,0,0)
yos = c(0,1,2,10,20,30,40,50,60,70,80,100,120,180)
yos = c(180)
ns  = length(yos)
n     = 400
nsim  = 50

for (yo in yos ) {
x     = matrix(rep(NA, (p-1)*n), ncol=p-1, byrow=FALSE)
y     = rep(NA, n)
nout  = round(epsilon*n)
m     = n-nout
yout  = yo

BetaA1 = BetaA2 = BetaA3 = BetaA4 = BetaA5 = BetaA6 = AlphaA = rep(NA,nsim)

for (i in 1:nsim) { 
set.seed(123+i)
x[1:m,]     = mvrnorm(m, Mu0, Sigma0)
if (nout!=0) x[(m+1):(m+nout),] =matrix(rep(xout,nout),ncol=p-1,byrow=TRUE)
Mu0xi = exp(cbind(1,x[,1:(p-1)])%*%Beta0)
y     = rnbinom(m, mu=Mu0xi, size=size0)
if (nout!=0) {y[(m+1):(m+nout)] = yout}

C1 = (yout==100 & i==15)
C2 = (yout==100 & i==44)
C3 = (yout==120 & i==15)
C4 = (yout==120 & i==44)
C5 = (yout==180 & i== 9)
C6 = (yout==180 & i==15)
C7 = (yout==180 & i==44)
C8 = (yout==180 & i==28)
C9 = (yout==180 & i==32)

if ( !(C1 | C2 | C3 | C4 | C5 | C6 | C7 | C8 | C9) ) {
ACH <- glmrob.nb(y,cbind(1,x), bounding.func="T/T", c.tukey.beta=4, c.tukey.sig=4, weights.on.x='hard')
acf = ACH$coef
if (length(acf)!=0) {
AlphaA[i]=acf[1]
BetaA1[i]=acf[2]
BetaA2[i]=acf[3]
BetaA3[i]=acf[4]
BetaA4[i]=acf[5]
BetaA5[i]=acf[6]
BetaA6[i]=acf[7] } }

cat(yout, i, " ", BetaA1[i],BetaA2[i],BetaA3[i],BetaA4[i],BetaA5[i],BetaA6[i]," ", AlphaA[i],"\n")
} # end i 

resdir <- "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_ACH_Out/"
resfile=paste(c(resdir, "SimMult_ACH_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
save(BetaA1, BetaA2, BetaA3, BetaA4, BetaA5, BetaA6, AlphaA, file=resfile )
} # end yo


