# SimMult_ML_Out

library(MASS)
library(robustnegbin)

remove(list=ls())

#-------------------------------------------------------------------------------
   
p = 6; Sigma0 = diag(1,p-1); Mu0 = c(0,0,0,0,0)
Beta0  = c(1.5, 0.5, 0.25,0,0,0); alpha0 = 0.8; size0  = 1/alpha0

epsilon = 0.15
xout = c(-2,-1,0,0,0)
yos  = c(0,1,2,10,20,30,40,50,60,70,100,120,180)
n     = 400
nsim  = 50

for (yo in yos) {
x     = matrix(rep(NA, (p-1)*n), ncol=p-1, byrow=FALSE)
y     = rep(NA, n)
nout  = round(epsilon*n)
m     = n-nout
yout  = yo

BetaG1 = BetaG2 = BetaG3 = BetaG4 = BetaG5 = BetaG6 = AlphaG = rep(NA,nsim)

for (i in 1:nsim) { 
set.seed(123+i)

x[1:m,]     = mvrnorm(m, Mu0, Sigma0)
if (nout!=0) x[(m+1):(m+nout),] =matrix(rep(xout,nout),ncol=p-1,byrow=TRUE)
Mu0xi = exp(cbind(1,x[,1:(p-1)])%*%Beta0)
y     = rnbinom(m, mu=Mu0xi, size=size0)
if (nout!=0) {y[(m+1):(m+nout)] = yout}

XI = cbind(1,x[,1:(p-1)])
X  = XI[,2:p]
n  = length(y)

GLM0    = try(glm.nb(y~X, link=log, maxit=100,epsilon=1e-7))
if (class(GLM0)!="try-error"){
 BetaG   = GLM0$coef
 alphaG  = 1/GLM0$theta 
 BetaG1[i]  = BetaG[1]
 BetaG2[i]  = BetaG[2]
 BetaG3[i]  = BetaG[3]
 BetaG4[i]  = BetaG[4]
 BetaG5[i]  = BetaG[5]
 BetaG6[i]  = BetaG[6]
 AlphaG[i]  = alphaG}

cat(yout, i, " ", BetaG1[i],BetaG2[i],BetaG3[i],BetaG4[i],BetaG5[i],BetaG6[i]," ", AlphaG[i],"\n")

} # end i 

resdir <- "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_ML_Out/"
resfile=paste(c(resdir, "SimMult_ML_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
save(BetaG1, BetaG2, BetaG3, BetaG4, BetaG5, BetaG6, AlphaG, file=resfile )

} # end yos



