# StatsMult_Out.s

library(MASS)

remove(list=ls())

p=6
Sigma0 = diag(1,p-1); Mu0 = c(0,0,0,0,0)
Beta0  = c(1.5, 0.5, 0.25,0,0,0); alpha0 = 0.8; size0  = 1/alpha0; sigma0 = sqrt(Sigma0)

nsim = 50
n    = 400
yout = 20

INIdir= "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_INI_Out/"
resfile=paste(c(INIdir, "SimMult_wINI_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
FINdir  = "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_FIN_Out/"
resfile = paste(c(FINdir, "SimMult_wFIN_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
ACHdir  = "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_ACH_Out/"
resfile = paste(c(ACHdir, "SimMult_ACH_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="")
load(file=resfile )
#
MD1dir  =  "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_M1_Out/"
resfile = resfile=paste(c(MD1dir, "SimMult_M1_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
MDXdir  =  "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_MX_Out/"
resfile = resfile=paste(c(MDXdir, "SimMult_MX_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )

par(mfrow=c(2,3))
boxplot(BetaI1,BetaC1,BetaA1,Betam1,BetaX1); abline(h=Beta0[1])
boxplot(BetaI2,BetaC2,BetaA2,Betam2,BetaX2); abline(h=Beta0[2])
boxplot(BetaI3,BetaC3,BetaA3,Betam3,BetaX3); abline(h=Beta0[3])
boxplot(BetaI4,BetaC4,BetaA4,Betam4,BetaX4); abline(h=Beta0[4])
boxplot(BetaI5,BetaC5,BetaA5,Betam5,BetaX5); abline(h=Beta0[5])
boxplot(BetaI6,BetaC6,BetaA6,Betam6,BetaX6); abline(h=Beta0[6])

#----------------------------------------------------------------------------------------------------------------------------------------------

remove(list=ls())

# MAPE of Coefficients and alpha
# ------------------------------

p=6
Sigma0 = diag(1,p-1); Mu0 = c(0,0,0,0,0)
Beta0  = c(1.5, 0.5, 0.25,0,0,0); alpha0 = 0.8; size0  = 1/alpha0; sigma0 = sqrt(Sigma0)

nsim=50
n = 400

fMAE <- function(x, a) {  mean( abs(x-a), na.rm=TRUE )  }
yos    = c(0,1,2,10,20,30,40,50,60,70,100,120,180)
nos    = length(yos)
MAEE.I = MAEE.C = MAEE.A = MAEE.m = MAEE.X = MAEE.T = rep(0,nos)
maee.I = maee.C = maee.A = maee.m = maee.X = maee.T = rep(0,nos)
no.lik = no.bnd = rep(0,nos)

for (k in 1:nos) {
yout = yos[k]

INIdir= "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_INI_Out/"
resfile=paste(c(INIdir, "SimMult_wINI_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
FINdir  = "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_FIN_Out/"
resfile = paste(c(FINdir, "SimMult_wFIN_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
ACHdir  = "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_ACH_Out/"
resfile = paste(c(ACHdir, "SimMult_ACH_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="")
load(file=resfile )
#
MD1dir  =  "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_M1_Out/"
resfile = resfile=paste(c(MD1dir, "SimMult_M1_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
MDXdir  =  "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_MX_Out/"
resfile = resfile=paste(c(MDXdir, "SimMult_MX_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )

errI = errC = errA = errm = errX = errT = rep(0,nsim)

for (i in 1:nsim) {
if (BetaC1[i] > 6) {
 BetaC1[i]=BetaI1[i]
 BetaC2[i]=BetaI2[i]
 BetaC2[i]=BetaI3[i]
 BetaC2[i]=BetaI4[i]
 BetaC2[i]=BetaI5[i]
 BetaC2[i]=BetaI6[i]
 Bound[i] = "yes"} 
BetaI   = c(BetaI1[i], BetaI2[i], BetaI3[i],BetaI4[i], BetaI5[i], BetaI6[i])
BetaC   = c(BetaC1[i], BetaC2[i], BetaC3[i],BetaC4[i], BetaC5[i], BetaC6[i])
BetaA   = c(BetaA1[i], BetaA2[i], BetaA3[i],BetaA4[i], BetaA5[i], BetaA6[i])
Betam   = c(Betam1[i], Betam2[i], Betam3[i],Betam4[i], Betam5[i], Betam6[i])
BetaX   = c(BetaX1[i], BetaX2[i], BetaX3[i],BetaX4[i], BetaX5[i], BetaX6[i])

errI[i] = sum(abs(BetaI-Beta0))
errC[i] = sum(abs(BetaC-Beta0))
errA[i] = sum(abs(BetaA-Beta0))
errm[i] = sum(abs(Betam-Beta0))
errX[i] = sum(abs(BetaX-Beta0))

} # end i

no.lik[k] = sum(Loglik > LoglikI)
no.bnd[k] = sum(Bound!="no")
maee.I[k] = fMAE(AlphaI,alpha0)
maee.C[k] = fMAE(AlphaC,alpha0)
maee.A[k] = fMAE(AlphaA,alpha0)
maee.m[k] = fMAE(Alpham,alpha0)
maee.X[k] = fMAE(AlphaX,alpha0)


MAEE.I[k] = mean(errI, na.rm = TRUE)
MAEE.C[k] = mean(errC, na.rm = TRUE)
MAEE.A[k] = mean(errA, na.rm = TRUE)
MAEE.m[k] = mean(errm, na.rm = TRUE)
MAEE.X[k] = mean(errX, na.rm = TRUE)

}

round(MAEE.I,2)
round(MAEE.C,2)
round(MAEE.A,2)
round(MAEE.m,2)
round(MAEE.X,2)

round(maee.I,2)
round(maee.C,2)
round(maee.A,2)
round(maee.m,2)
round(maee.X,2)

par(mfrow=c(2,2))
A = min(MAEE.I,MAEE.C,MAEE.A,MAEE.m,MAEE.X)
B = max(MAEE.I,MAEE.C,MAEE.A,MAEE.m,MAEE.X)
plot(yos,MAEE.I,ylim=c( A,B),type="n")
lines(yos,MAEE.A, lwd=3, col="grey")
lines(yos,MAEE.m, lwd=3, col="cyan")
lines(yos,MAEE.X, lwd=3, col="blue")
lines(yos,MAEE.I, lwd=3, col="green",)
lines(yos,MAEE.C, lwd=3, col="darkgreen")
lines(yos,MAEE.T, lwd=3, col="red")

points(yos,MAEE.A, col="gray",      pch=16,cex=2.1)
points(yos,MAEE.m, col="cyan",      pch=16,cex=1.5)
points(yos,MAEE.X, col="blue",      pch=16,cex=1.3)
points(yos,MAEE.I, col="green",     pch=16,cex=1.3)
points(yos,MAEE.C, col="darkgreen", pch=16,cex=1.3)

a = min(maee.I,maee.C,maee.A,maee.m,maee.X)
b = max(maee.I,maee.C,maee.A,maee.m,maee.X)
plot(yos,maee.I,ylim=c( a,b),type="n")
lines(yos,maee.A, lwd=3, col="grey")
lines(yos,maee.m, lwd=3, col="cyan")
lines(yos,maee.X, lwd=3, col="blue")
lines(yos,maee.I, lwd=3, col="green",)
lines(yos,maee.C, lwd=3, col="darkgreen")

points(yos,maee.A, col="gray",      pch=16,cex=2.1)
points(yos,maee.m, col="cyan",      pch=16,cex=1.5)
points(yos,maee.X, col="blue",      pch=16,cex=1.3)
points(yos,maee.I, col="green",     pch=16,cex=1.3)
points(yos,maee.C, col="darkgreen", pch=16,cex=1.3)

#----------------------------------------------------------------------------------------------------------------------------------------------

# MAPE of prediction mu
# ---------------------

p=6
Sigma0 = diag(1,p-1); Mu0 = c(0,0,0,0,0)
Beta0  = c(1.5, 0.5, 0.25,0,0,0); alpha0 = 0.8; size0  = 1/alpha0

epsilon = 0.15
xout = c(-2,-1,0,0,0)
yos  = c(0,1,2,10,20,30,40,50,60,70,100,120,180)
n     = 400
nsim  = 50

K = length(yos)
STATI = STATC = STATA = STATm = STATX = STATT = matrix(rep(0, nsim*K), nrow=K, byrow=TRUE)
mI = mC = mA =mm = mX = mT = MI = MC = MA = Mm = MX = MT = rep(0,K)

for (k in 1:K) {
yout  = yos[k]
x     = matrix(rep(NA, (p-1)*n), ncol=p-1, byrow=FALSE)
y     = rep(NA, n)
nout  = round(epsilon*n)
m     = n-nout
#
INIdir= "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_INI_Out/"
resfile=paste(c(INIdir, "SimMult_wINI_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
FINdir  = "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_FIN_Out/"
resfile = paste(c(FINdir, "SimMult_wFIN_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
ACHdir  = "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_ACH_Out/"
resfile = paste(c(ACHdir, "SimMult_ACH_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="")
load(file=resfile )
#
MD1dir  =  "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_M1_Out/"
resfile = resfile=paste(c(MD1dir, "SimMult_M1_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
MDXdir  =  "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_MX_Out/"
resfile = resfile=paste(c(MDXdir, "SimMult_MX_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
for (i in 1:nsim) {
if (BetaC1[i] > 6) {
 BetaC1[i]=BetaI1[i]
 BetaC2[i]=BetaI2[i]
 BetaC2[i]=BetaI3[i]
 BetaC2[i]=BetaI4[i]
 BetaC2[i]=BetaI5[i]
 BetaC2[i]=BetaI6[i]
 Bound[i] = "yes"} }

for (i in (1:nsim)) { 
set.seed(123+i) 
x[1:m,]     = mvrnorm(m, Mu0, Sigma0)
if (nout!=0) x[(m+1):(m+nout),] =matrix(rep(xout,nout),ncol=p-1,byrow=TRUE)
Mu0xi = exp(cbind(1,x[,1:(p-1)])%*%Beta0)
y     = rnbinom(m, mu=Mu0xi, size=size0)
if (nout!=0) {y[(m+1):(m+nout)] = yout}
BetaI  = c(BetaI1[i], BetaI2[i], BetaI3[i],BetaI4[i], BetaI5[i], BetaI6[i])
BetaC  = c(BetaC1[i], BetaC2[i], BetaC3[i],BetaC4[i], BetaC5[i], BetaC6[i])
BetaA  = c(BetaA1[i], BetaA2[i], BetaA3[i],BetaA4[i], BetaA5[i], BetaA6[i])
Betam  = c(Betam1[i], Betam2[i], Betam3[i],Betam4[i], Betam5[i], Betam6[i])
BetaX  = c(BetaX1[i], BetaX2[i], BetaX3[i],BetaX4[i], BetaX5[i], BetaX6[i])

Mu0xj  = exp(cbind(1,x[1:m,1:(p-1)])%*%Beta0)
MuCxj  = exp(cbind(1,x[1:m,1:(p-1)])%*%BetaC)
MuIxj  = exp(cbind(1,x[1:m,1:(p-1)])%*%BetaI)
MuAxj  = exp(cbind(1,x[1:m,1:(p-1)])%*%BetaA)
Mumxj  = exp(cbind(1,x[1:m,1:(p-1)])%*%Betam)
MuXxj  = exp(cbind(1,x[1:m,1:(p-1)])%*%BetaX)

residC = MuCxj - Mu0xj
residI = MuIxj - Mu0xj
residA = MuAxj - Mu0xj
residm = Mumxj - Mu0xj
residX = MuXxj - Mu0xj

STATI[k,i] = mean(abs(residI),na.rm=TRUE)
STATC[k,i] = mean(abs(residC),na.rm=TRUE)
STATA[k,i] = mean(abs(residA),na.rm=TRUE)
STATm[k,i] = mean(abs(residm),na.rm=TRUE)
STATX[k,i] = mean(abs(residX),na.rm=TRUE)

} # end i

mI[k] =  mean(STATI[k,],trim=0.00,na.rm=TRUE)
mC[k] =  mean(STATC[k,],trim=0.00,na.rm=TRUE)
mA[k] =  mean(STATA[k,],trim=0.00,na.rm=TRUE)
mm[k] =  mean(STATm[k,],trim=0.00,na.rm=TRUE)
mX[k] =  mean(STATX[k,],trim=0.00,na.rm=TRUE)

cat(yout, round(mI[k],2), round(mC[k],2), round(mA[k],2), round(mm[k],2), round(mX[k],2), "\n")
} # end k

A = min(mI,mC,mA,mm,mX)
B = max(mI,mC,mA,mm,mX)
plot(yos,mI,ylim=c( A,B),type="n")
lines(yos,mA, lwd=3, col="grey")
lines(yos,mm, lwd=3, col="cyan")
lines(yos,mX, lwd=3, col="blue")
lines(yos,mI, lwd=3, col="green",)
lines(yos,mC, lwd=3, col="darkgreen")

points(yos,mA, col="gray",      pch=16,cex=2.1)
points(yos,mm, col="cyan",      pch=16,cex=1.5)
points(yos,mX, col="blue",      pch=16,cex=1.3)
points(yos,mI, col="green",     pch=16,cex=1.3)
points(yos,mC, col="darkgreen", pch=16,cex=1.3)

#------------------------------------------------------------------------------------------------------------------------------------

# KL divergence

KL.negbin <- function(Beta0,alpha0,Beta1,alpha1,X) {
m = dim(X)[1]
size1 = 1/alpha1
size0 = 1/alpha0
mu0x  = exp(cbind(1,X)%*%Beta0)
mu1x  = exp(cbind(1,X)%*%Beta1)
Ymax = D = rep(0,m)
Ymax = qnbinom(1-1e-6,size=size0,mu=mu0x)
for (i in 1:m) {
 Q = dnbinom((0:Ymax[i]), size=size0,mu=mu0x[i])  
 P = dnbinom((0:Ymax[i]), size=size1,mu=mu1x[i])  
 D[i] = sum (P*log(P/Q)) }
mean(D) }

p=6
Sigma0 = diag(1,p-1); Mu0 = c(0,0,0,0,0)
Beta0  = c(1.5, 0.5, 0.25,0,0,0); alpha0 = 0.8; size0  = 1/alpha0

n = 400
epsilon = 0.15
nout  = round(epsilon*n)
m     = n-nout
nsim  = 50

xout = c(-2,-1,0,0,0)
yos  = c(0,1,2,10,20,30,40,50,60,70,100,120,180)

mKLG = mKLm = mKLX = mKLI = mKLC = mKLA = mKLT = rep(NA,length(yos))
k = 0

for (yo in yos ) { k= k+1
x     = matrix(rep(NA, (p-1)*n), ncol=p-1, byrow=FALSE)
y     = rep(NA, n)
yout  = yo
KLm = KLX = KLI = KLC = KLA = KLT = rep(NA,nsim)
#
INIdir= "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_INI_Out/"
resfile=paste(c(INIdir, "SimMult_wINI_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
FINdir  = "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_FIN_Out/"
resfile = paste(c(FINdir, "SimMult_wFIN_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
ACHdir  = "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_ACH_Out/"
resfile = paste(c(ACHdir, "SimMult_ACH_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="")
load(file=resfile )
#
MD1dir  =  "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_M1_Out/"
resfile = resfile=paste(c(MD1dir, "SimMult_M1_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
MDXdir  =  "C:/Users/Alfio/Desktop/SimulPrograms/Sim_Mult_Rev_Out/SimMult_MX_Out/"
resfile = resfile=paste(c(MDXdir, "SimMult_MX_Out_n", n, "_yout", yout, "_nsim", nsim, ".dmp"), collapse="") 
load(file=resfile )
#
for (i in (1:nsim)) { 
 set.seed(123+i) 
 x[1:m,]     = mvrnorm(m, Mu0, Sigma0)
 if (nout!=0) x[(m+1):(m+nout),] =matrix(rep(xout,nout),ncol=p-1,byrow=TRUE)
 Mu0xi = exp(cbind(1,x[,1:(p-1)])%*%Beta0)
 y     = rnbinom(m, mu=Mu0xi, size=size0)
 if (nout!=0) {y[(m+1):(m+nout)] = yout}
 XI = cbind(1,x[,1:(p-1)])
 X  = XI[,2:p]
 BetaI  = c(BetaI1[i], BetaI2[i], BetaI3[i],BetaI4[i], BetaI5[i], BetaI6[i]); alphaI = AlphaI[i]
 BetaC  = c(BetaC1[i], BetaC2[i], BetaC3[i],BetaC4[i], BetaC5[i], BetaC6[i]); alphaC = AlphaC[i]
 BetaA  = c(BetaA1[i], BetaA2[i], BetaA3[i],BetaA4[i], BetaA5[i], BetaA6[i]); alphaA = AlphaA[i]
 Betam  = c(Betam1[i], Betam2[i], Betam3[i],Betam4[i], Betam5[i], Betam6[i]); alpham = Alpham[i]
 BetaX  = c(BetaX1[i], BetaX2[i], BetaX3[i],BetaX4[i], BetaX5[i], BetaX6[i]); alphaX = AlphaX[i]

 KLA[i] = KL.negbin(Beta0,alpha0,BetaA,alphaA,X)
 KLm[i] = KL.negbin(Beta0,alpha0,Betam,alpham,X)    
 KLX[i] = KL.negbin(Beta0,alpha0,BetaX,alphaX,X)
 KLI[i] = KL.negbin(Beta0,alpha0,BetaI,alphaI,X)
 KLC[i] = KL.negbin(Beta0,alpha0,BetaC,alphaC,X)

} # end i

trim=0.0
mKLA[k] =  mean(KLA,trim=trim, na.rm=TRUE)
mKLm[k] =  mean(KLm,trim=trim, na.rm=TRUE)
mKLX[k] =  mean(KLX,trim=trim, na.rm=TRUE)
mKLI[k] =  mean(KLI,trim=trim, na.rm=TRUE)
mKLC[k] =  mean(KLC,trim=trim, na.rm=TRUE)

cat(yout,round(mKLA[k],3),round(mKLm[k],3),round(mKLX[k],3),round(mKLI[k],3),round(mKLC[k],3), "\n")
} # end k

yliml=min(mKLA,mKLX,mKLm,mKLI,mKLX)
ylimu=max(mKLA,mKLX,mKLm,mKLI,mKLC)
plot(yos,mKLC,ylim=c(yliml,ylimu), type="n", ylab="", xlab="")
lines(yos, mKLA, col="gray",       lwd=3)
lines(yos, mKLm, col="cyan",       lwd=3)
lines(yos, mKLX, col="blue",       lwd=3)
lines(yos, mKLI, col="green",      lwd=3)
lines(yos, mKLC, col="darkgreen",  lwd=3)

points(yos,mKLA, col="gray",      pch=16,cex=2.1)
points(yos,mKLm, col="cyan",      pch=16,cex=1.5)
points(yos,mKLX, col="blue",      pch=16,cex=1.3)
points(yos,mKLI, col="green",     pch=16,cex=1.3)
points(yos,mKLC, col="darkgreen", pch=16,cex=1.3)
ytext = "MKL" ;            title(ylab=ytext,cex.lab=1)

#===========================================================================================================================

#postscript(file="C:/Users/Alfio/Desktop/Revision/Simulations/Sim_Mult_Rev_Out/GraphsMult_Out2.ps",width=18.5/2.54,height=20/2.54,horizon=FALSE)
par(mfrow=c(2,2),mar=c(1.5,3.1,0.5,0.1),mgp=c(1.5,0.5,0),oma=c(0,0,0,0))

A = min(MAEE.I,MAEE.C,MAEE.A,MAEE.m,MAEE.X)
B = max(MAEE.I,MAEE.C,MAEE.A,MAEE.m,MAEE.X)
plot(yos,MAEE.I,ylim=c( A,B),type="n", ylab="", xlab="")
lines(yos,MAEE.A, lwd=3, col="grey")
lines(yos,MAEE.m, lwd=3, col="cyan")
lines(yos,MAEE.X, lwd=3, col="blue")
lines(yos,MAEE.I, lwd=3, col="green",)
lines(yos,MAEE.C, lwd=3, col="darkgreen")
lines(yos,MAEE.T, lwd=3, col="red")
points(yos,MAEE.A, col="gray",      pch=16,cex=2.1)
points(yos,MAEE.m, col="cyan",      pch=16,cex=1.5)
points(yos,MAEE.X, col="blue",      pch=16,cex=1.3)
points(yos,MAEE.I, col="green",     pch=16,cex=1.3)
points(yos,MAEE.C, col="darkgreen", pch=16,cex=1.3)
ytext = "MAEE(Beta)" ; title(ylab=ytext,cex.lab=1)

a = min(maee.I,maee.C,maee.A,maee.m,maee.X)
b = max(maee.I,maee.C,maee.A,maee.m,maee.X)
plot(yos,maee.I,ylim=c( a,b),type="n", ylab="", xlab="")
lines(yos,maee.A, lwd=3, col="grey")
lines(yos,maee.m, lwd=3, col="cyan")
lines(yos,maee.X, lwd=3, col="blue")
lines(yos,maee.I, lwd=3, col="green",)
lines(yos,maee.C, lwd=3, col="darkgreen")
lines(yos,maee.T, lwd=3, col="red")
points(yos,maee.A, col="gray",      pch=16,cex=2.1)
points(yos,maee.m, col="cyan",      pch=16,cex=1.5)
points(yos,maee.X, col="blue",      pch=16,cex=1.3)
points(yos,maee.I, col="green",     pch=16,cex=1.3)
points(yos,maee.C, col="darkgreen", pch=16,cex=1.3)
ytext = "MAEE(alpha)" ; title(ylab=ytext,cex.lab=1)

A = min(mI,mC,mA,mm,mX)
B = max(mI,mC,mA,mm,mX)
plot(yos,mI,ylim=c( A,B),type="n", ylab="", xlab="")
lines(yos,mA, lwd=3, col="grey")
lines(yos,mm, lwd=3, col="cyan")
lines(yos,mX, lwd=3, col="blue")
lines(yos,mI, lwd=3, col="green",)
lines(yos,mC, lwd=3, col="darkgreen")
lines(yos,mT, lwd=3, col="red")
points(yos,mA, col="gray",      pch=16,cex=2.1)
points(yos,mm, col="cyan",      pch=16,cex=1.5)
points(yos,mX, col="blue",      pch=16,cex=1.3)
points(yos,mI, col="green",     pch=16,cex=1.3)
points(yos,mC, col="darkgreen", pch=16,cex=1.3)
ytext = "MAPE(mu)" ; title(ylab=ytext,cex.lab=1)

yliml=min(mKLA,mKLX,mKLm,mKLI,mKLX)
ylimu=max(mKLA,mKLX,mKLm,mKLI,mKLC)
plot(yos,mKLC,ylim=c(yliml,ylimu), type="n", ylab="", xlab="")
lines(yos, mKLA, col="gray",       lwd=3)
lines(yos, mKLm, col="cyan",       lwd=3)
lines(yos, mKLX, col="blue",       lwd=3)
lines(yos, mKLI, col="green",      lwd=3)
lines(yos, mKLC, col="darkgreen",  lwd=3)
lines(yos, mKLT, col="red",        lwd=3)
points(yos,mKLA, col="gray",      pch=16,cex=2.1)
points(yos,mKLm, col="cyan",      pch=16,cex=1.5)
points(yos,mKLX, col="blue",      pch=16,cex=1.3)
points(yos,mKLI, col="green",     pch=16,cex=1.3)
points(yos,mKLC, col="darkgreen", pch=16,cex=1.3)
points(yos,mKLT, col="red", pch=16,cex=1.3)
ytext = "MKL" ; title(ylab=ytext,cex.lab=1)

#dev.off()
