# Simul_ACH_noOut.s

library(MASS)
remove(list=ls())

source(file="C:/Users/Alfio/Desktop/Negbin_Todo/AeberhardCantoniHeritier/glmrob.nb_V3.r")         

#-------------------------------------------------------------------------------
   
p = 6; Sigma0 = diag(1,p-1); Mu0 = c(0,0,0,0,0)
Beta0  = c(1.5, 0.5, 0.25,0,0,0); alpha0 = 0.8; size0  = 1/alpha0

nsim  = 1000

for (n in c(100,400,1000,2000) ) {
x     = matrix(rep(NA, (p-1)*n), ncol=p-1, byrow=FALSE)
y     = rep(NA, n)

BetaA1 = BetaA2 = BetaA3 = BetaA4 = BetaA5 = BetaA6 = AlphaA = rep(NA,nsim)

for (i in 1:nsim) { 
set.seed(123+i)
x[1:n,]     = mvrnorm(n, Mu0, Sigma0)
Mu0xi = exp(cbind(1,x[,1:(p-1)])%*%Beta0)
y     = rnbinom(n, mu=Mu0xi, size=size0)

ACH <- glmrob.nb(y,cbind(1,x), bounding.func="T/T", c.tukey.beta=4, c.tukey.sig=4, weights.on.x='hard')
acf = ACH$coef
if (length(acf)!=0) {
AlphaA[i]=acf[1]
BetaA1[i]=acf[2]
BetaA2[i]=acf[3]
BetaA3[i]=acf[4]
BetaA4[i]=acf[5]
BetaA5[i]=acf[6]
BetaA6[i]=acf[7] }

cat(n, i, " ", BetaA1[i],BetaA2[i],BetaA3[i],BetaA4[i],BetaA5[i],BetaA6[i]," ", AlphaA[i],"\n")
} # end i 

resdir  = "C:/Users/Alfio/Desktop/SimulPrograms/Simul_Mult_Rev_NoOut/SimMult_ACH_noOut/"
resfile = paste(c(resdir, "SimMult_wACHx_noOut_n", n, ".dmp"), collapse="") 
save(BetaA1, BetaA2, BetaA3, BetaA4, BetaA5, BetaA6, AlphaA, file=resfile )
} # end n

