# Simul_ML_noOut.s

library(MASS)         

remove(list=ls())

#-------------------------------------------------------------------------------
   
p = 6; Sigma0 = diag(1,p-1); Mu0 = c(0,0,0,0,0)
Beta0  = c(1.5, 0.5, 0.25,0,0,0); alpha0 = 0.1; size0  = 1/alpha0

nn = c(100,400,1000,2000)

nsim = 1000

for (n in nn) {

x     = matrix(rep(NA, (p-1)*n), ncol=p-1, byrow=FALSE)
y     = rep(NA, n)

BetaG1 = BetaG2 = BetaG3 = BetaG4 = BetaG5 = BetaG6 = AlphaG = rep(0,nsim)

for (i in 1:nsim) { 
set.seed(123+i)
x[1:n,]     = mvrnorm(n, Mu0, Sigma0)
Mu0xi = exp(cbind(1,x[,1:(p-1)])%*%Beta0)
y     = rnbinom(n, mu=Mu0xi, size=size0)

XI = cbind(1,x[,1:(p-1)])
X  = XI[,2:p]
n  = length(y)

#C1 = (i==278)
#C2 = (i==647)
#if (!(C1 | C2)) {

GLM0    = glm.nb(y~X, link=log, maxit=100,epsilon=1e-7)
BetaG   = GLM0$coef
alphaG  = 1/GLM0$theta 
BetaG1[i]  = BetaG[1]
BetaG2[i]  = BetaG[2]
BetaG3[i]  = BetaG[3]
BetaG4[i]  = BetaG[4]
BetaG5[i]  = BetaG[5]
BetaG6[i]  = BetaG[6]
AlphaG[i]  = alphaG 
#}

cat(n, i, " ", BetaG1[i],BetaG2[i],BetaG3[i],BetaG4[i],BetaG5[i],BetaG6[i]," ", AlphaG[i],"\n")
} # end i 

resdir <- "C:/Users/Alfio/Desktop/SimulPrograms/Simul_Mult_Rev_NoOut/SimMult_ML_noOut/"
resfile = paste(c(resdir, "SimMult_ML8_noOut_n", n, ".dmp"), collapse="") 
save(BetaG1, BetaG2, BetaG3, BetaG4, BetaG5, BetaG6, AlphaG, file=resfile )
} # end n

