# Stats_pred_noOut.s

library(MASS)

p = 6; Sigma0 = diag(1,p-1); Mu0 = c(0,0,0,0,0)
Beta0  = c(1.5, 0.5, 0.25,0,0,0); alpha0 = 0.8; size0  = 1/alpha0

nn = c(100,400,1000,2000)
nsim = 1000
trim=0

STATI  = STATC  = STATc = STATG = STATA = STATa = STATd = matrix(rep(0, nsim*4), nrow=4, byrow=TRUE)
mI = mC = mc = mG = mA = ma = md = rep(0,4)

fMAE <- function(x, a, trim) {  mean( abs(x-a), trim )  }

for (k in 1:length(nn)) {
n = nn[k]

resdir <- "C:/Users/Alfio/Desktop/SimulPrograms/Simul_Mult_Rev_NoOut/SimMult_ML_noOut/"
resfile = paste(c(resdir, "SimMult_ML8_noOut_n", n, ".dmp"), collapse="") 
load(file=resfile )

resdir <- "C:/Users/Alfio/Desktop/SimulPrograms/Simul_Mult_Rev_NoOut/SimMult_ACH_noOut/"
resfile = paste(c(resdir, "SimMult_ACH8_noOut_n", n, ".dmp"), collapse="") 
load(file=resfile )
Betaa1 = BetaA1; Betaa2=BetaA2; Betaa3 = BetaA3; Betaa4=BetaA4; Betaa5 = BetaA5; Betaa6=BetaA6;
Alphaa = AlphaA

resdir <- "C:/Users/Alfio/Desktop/SimulPrograms/Simul_Mult_Rev_NoOut/SimMult_ACH_noOut/"
resfile = paste(c(resdir, "SimMult_wACH8_noOut_n", n, ".dmp"), collapse="") 
load(file=resfile )

resdir <- "C:/Users/Alfio/Desktop/SimulPrograms/Simul_Mult_Rev_NoOut/SimMult_INI_noOut/"
resfile=paste(c(resdir, "SimMult_wINI8_noOut_n", n, ".dmp"), collapse="")
load(resfile)

resdir <- "C:/Users/Alfio/Desktop/SimulPrograms/Simul_Mult_Rev_NoOut/SimMult_FIN_noOut/"
resfile=paste(c(resdir, "SimMult_wFIN8_noOut_n", n, ".dmp"), collapse="") 
load(resfile)

resdir <- "C:/Users/Alfio/Desktop/SimulPrograms/Simul_Mult_Rev_NoOut/SimMult_MDE_noOut/"
resfile=paste(c(resdir, "SimMult_MDE8_noOut_n", n, "_0.4", ".dmp"), collapse="") 
load(resfile)
Betad1 = BetaD1; Betad2=BetaD2; Betad3 = BetaD3; Betad4=BetaD4; Betad5 = BetaD5; Betad6=BetaD6;
Alphad = AlphaD

x     = matrix(rep(NA, (p-1)*n), ncol=p-1, byrow=FALSE)
y     = rep(NA, n)

for (i in (1:nsim)) { 
set.seed(123+i) 
x[1:n,] = mvrnorm(n, Mu0, Sigma0)
Mu0xi   = exp(cbind(1,x[,1:(p-1)])%*%Beta0)
y       = rnbinom(n, mu=Mu0xi, size=size0)

BetaG  = c(BetaG1[i], BetaG2[i], BetaG3[i],BetaG4[i], BetaG5[i], BetaG6[i])
BetaA  = c(BetaA1[i], BetaA2[i], BetaA3[i],BetaA4[i], BetaA5[i], BetaA6[i])
Betaa  = c(Betaa1[i], Betaa2[i], Betaa3[i],Betaa4[i], Betaa5[i], Betaa6[i])
Betad  = c(Betad1[i], Betad2[i], Betad3[i],Betad4[i], Betad5[i], Betad6[i])
BetaI  = c(BetaI1[i], BetaI2[i], BetaI3[i],BetaI4[i], BetaI5[i], BetaI6[i])
BetaC  = c(BetaC1[i], BetaC2[i], BetaC3[i],BetaC4[i], BetaC5[i], BetaC6[i])

Mu0xj  = exp(cbind(1,x[1:n,1:(p-1)])%*%Beta0)
MuGxj  = exp(cbind(1,x[1:n,1:(p-1)])%*%BetaG)
MuAxj  = exp(cbind(1,x[1:n,1:(p-1)])%*%BetaA)
Muaxj  = exp(cbind(1,x[1:n,1:(p-1)])%*%Betaa)
Mudxj  = exp(cbind(1,x[1:n,1:(p-1)])%*%Betad)
MuIxj  = exp(cbind(1,x[1:n,1:(p-1)])%*%BetaI)
MuCxj  = exp(cbind(1,x[1:n,1:(p-1)])%*%BetaC)

residG = MuGxj - Mu0xj
residA = MuAxj - Mu0xj
resida = Muaxj - Mu0xj
residd = Mudxj - Mu0xj
residI = MuIxj - Mu0xj
residC = MuCxj - Mu0xj

STATG[k,i] = mean(abs(residG), na.rm = TRUE)
STATA[k,i] = mean(abs(residA), na.rm = TRUE)
STATa[k,i] = mean(abs(resida), na.rm = TRUE)
STATd[k,i] = mean(abs(residd), na.rm = TRUE)
STATI[k,i] = mean(abs(residI), na.rm = TRUE)
STATC[k,i] = mean(abs(residC), na.rm = TRUE)


} # end i 

mG[k] =  mean(STATG[k,],trim=trim, na.rm = TRUE)
mA[k] =  mean(STATA[k,],trim=trim, na.rm = TRUE)
ma[k] =  mean(STATa[k,],trim=trim, na.rm = TRUE)
md[k] =  mean(STATd[k,],trim=trim, na.rm = TRUE)
mI[k] =  mean(STATI[k,],trim=trim, na.rm = TRUE)
mC[k] =  mean(STATC[k,],trim=trim, na.rm = TRUE)

cat(n, round(mG[k]/mI[k],3), round(mG[k]/mA[k],3), round(mG[k]/ma[k],3), round(mG[k]/md[k],3), round(mG[k]/mC[k],3), "\n")
} # end k


 100 0.797 0.738 0.822 0.856 0.801 0.896 
 400 0.832 0.767 0.833 0.870 0.891 0.977 
1000 0.845 0.775 0.835 0.871 0.933 0.989 
2000 0.859 0.773 0.835 0.876 0.949 0.995 

